function [figh1,figh2] = boxplot3d(xc,flagbdr,ibox,icenter)

        % Plot boxes and overlapping balls
        w = cat(1,ibox(icenter).midpt);
        wdimen = cat(1,ibox(icenter).dimen);
        wR = cat(1,ibox(icenter).R);
        boxcorner = [-1 -1 -1; 1 -1 -1; 1 1 -1; -1 1 -1; ...
                     -1 -1  1; 1 -1  1; 1 1  1; -1 1  1];
        vm = zeros(8,3);
        fm = [1 2 6 5; 2 3 7 6; 3 4 8 7; ...
              4 1 5 8; 1 2 3 4; 5 6 7 8];
        [xx,yy,zz]=sphere(8);
        [tt,pp,rr]=cart2sph(xx,yy,zz);
        for i=1:sum(icenter)
            % Plot boxes and its centers
            plot3(w(i,1),w(i,2),w(i,3),'ok','markerfacecolor','g'); hold on;
            vm(:,1) = w(i,1) + 0.5*wdimen(i,1)*boxcorner(:,1);
            vm(:,2) = w(i,2) + 0.5*wdimen(i,2)*boxcorner(:,2);
            vm(:,3) = w(i,3) + 0.5*wdimen(i,3)*boxcorner(:,3);
            patch('Vertices',vm,'Faces',fm,'EdgeColor','r','FaceAlpha',0);
            %xlim([1.01*x1,1.01*x2]); ylim([1.01*y1,1.01*y2]); zlim([1.01*z1,1.01*z2]); 
            xlim([-1.2,1.2]); ylim([-1.2,1.2]); zlim([-1.2,1.2]);
            xlabel('x'); ylabel('y'); zlabel('z')
            %RR = wR(i)*rr;
            %[xx,yy,zz]=sph2cart(tt,pp,RR);
            %xx = w(i,1) + xx; yy = w(i,2) + yy; zz = w(i,3) + zz;
            %surf(xx,yy,zz,'EdgeColor','k','FaceAlpha',0);
            %mesh(xx,yy,zz,'EdgeColor','k','meshstyle','column','FaceAlpha',0)
            %view(45,0)
            %drawnow
            %pause
        end
        
        % Plot stuff
        plot3(xc(:,1),xc(:,2),xc(:,3),'*b')
        figh1 = plot3(xc(flagbdr,1),xc(flagbdr,2),xc(flagbdr,3),'xb');
        plot3(xc(flagbdr,1),xc(flagbdr,2),xc(flagbdr,3),'o','markerfacecolor','g')
        figh2 = plot3(xc(flagbdr,1),xc(flagbdr,2),xc(flagbdr,3),'ob','markerfacecolor','r');
        set(gca,'plotboxaspectratio',[1 1 1])
end

