function [w,wx,wy,wz,wL] = gaweights(ep,xc,xe)

N = size(xc,1);
M = size(xe,1);
A = deal(zeros(N,N));
[Ae,Aex,Aey,Aez,L] = deal(zeros(M,N));
for i=1:size(xc,1)
    r2 = (xc(:,1)-xc(i,1)).^2 + (xc(:,2)-xc(i,2)).^2 + (xc(:,3)-xc(i,3)).^2;
    A(:,i) = exp(-ep^2*r2);
    dx = xe(:,1)-xc(i,1);
    dy = xe(:,2)-xc(i,2);
    dz = xe(:,3)-xc(i,3);
    r2 = dx.^2 + dy.^2 + dz.^2;
    Ae(:,i) = exp(-ep^2*r2);
    Aex(:,i) = -2*ep^2*dx.*Ae(:,i);
    Aey(:,i) = -2*ep^2*dy.*Ae(:,i);
    Aez(:,i) = -2*ep^2*dz.*Ae(:,i);
    L(:,i) = ep^2*(-6+4*ep^2*r2).*Ae(:,i);
end

w = Ae/A;
wx = Aex/A;
wy = Aey/A;
wz = Aez/A;
wL = L/A;

end

