function [qbox,qdist] = getcircindices(xi,box,nbox,center)
% Get indices of circles containing xi using 
% depth-first search algorithm.

%numdist = 0;
q = 30;
qbox = zeros(q,1); qdist = qbox; 
queuenn = eye(nbox,1);
iend = 0; 
nqueue = 1; endqueue = nqueue;
n = 8;
vec1n = 1:n;

r = inf;  % ceiling on the radius
%rconst = 0.5*sqrt(2);

while nqueue <= endqueue
    b = queuenn(nqueue);
    nqueue = nqueue+1;
 
    % Compute distance
    dist = sqrt(sum((xi-box(b).midpt).^2));
    %numdist = numdist+1;

    % Test box for intersection with the r-disk around x
    %if dist > (r + rconst*box(b).dimen(1)), continue, end
    if dist > box(b).R, continue, end

    if ~center(b)
        if isempty(box(b).child), continue, end
            
        queuenn(endqueue+vec1n) = box(b).child;
        endqueue = endqueue + n;
    elseif dist < r      
        iend = min(q-1,iend) + 1;
        qbox(iend) = b;
        qdist(iend) = dist;
        % Sort in order of distance
        [qdist(1:iend),idx] = sort(qdist(1:iend));
        qbox(1:iend) = qbox(idx);
           
        if q == iend
            % Reduce search range
            r = qdist(end);
        end
    end
end

% Get rid off trailing zeros
qbox(iend+1:end) = [];
if length(qbox) == q
    display('increase the number of qbox')
    keyboard
end
qdist(iend+1:end) = [];
