function [w,wx,wy,wz,wxx,wyy,wzz] = puweight(x,indcirc,box)

n = length(indcirc);
[s,sx,sy,sz,sxx,syy,szz] = deal(0);
for i=1:n
    [phi,phix,phiy,phiz,phixx,phiyy,phizz] = csrbf(x,box(indcirc(i)).midpt,box(indcirc(i)).R);
    s = s + phi;
    sx = sx + phix;
    sy = sy + phiy;
    sz = sz + phiz;
    sxx = sxx + phixx;
    syy = syy + phiyy;
    szz = szz + phizz;
end

[w,wx,wy,wz,wxx,wyy,wzz] = deal(zeros(n,1));
for i=1:n
    [phi,phix,phiy,phiz,phixx,phiyy,phizz] = csrbf(x,box(indcirc(i)).midpt,box(indcirc(i)).R);
    w(i) =  phi/s;
    wx(i) = phix/s - phi*sx/s^2;
    wy(i) = phiy/s - phi*sy/s^2;
    wz(i) = phiz/s - phi*sz/s^2;
    wxx(i) = -2*phix*sx/s^2 + phixx/s + phi*(2*sx^2/s^3 - sxx/s^2);
    wyy(i) = -2*phiy*sy/s^2 + phiyy/s + phi*(2*sy^2/s^3 - syy/s^2);
    wzz(i) = -2*phiz*sz/s^2 + phizz/s + phi*(2*sz^2/s^3 - szz/s^2);
end

